local tempVector1 = Vector3f.new()
local tempVector2 = Vector3f.new()

local function move_vehicle(vehicle, x_delta, y_delta, z_delta)
    local field = getClassField(vehicle, 157)
    local tmpTransform = field:get(vehicle)

    local wTranform = vehicle:getWorldTransform(tmpTransform)
    local originField = getClassField(wTranform, 1)
    local origin = originField:get(wTranform)

    origin:set(origin:x() + x_delta, origin:y() + y_delta, origin:z() + z_delta)

    vehicle:setWorldTransform(wTranform)
end

local function heli_update()
    local playerObj = getPlayer()
    if playerObj == nil then return end

    local vehicle = playerObj:getVehicle()
    if vehicle == nil then return end
    if vehicle:getScript():getFullName() ~= "Base.AI_helicopter_veh" then return end
    if not playerObj:isRecipeKnown("Heli driving") then 
        if isKeyDown(Keyboard.KEY_W) then
            playerObj:Say(getText("Tooltip_I_dont_know"))
        end
        return 
    end
    if not vehicle:isEngineRunning() then return end

    playerObj:setZ(vehicle:getWorldPos(0, 0, 0, tempVector1):z())
    vehicle:setZ(vehicle:getWorldPos(0, 0, 0, tempVector1):z())

    vehicle:getPartById("GasTank"):setContainerContentAmount(vehicle:getPartById("GasTank"):getContainerContentAmount() - 0.005)
    
    local delta_x = 0
    local delta_z = 0

    if isKeyDown(Keyboard.KEY_UP) then
        delta_z = -1
    end

    if isKeyDown(Keyboard.KEY_DOWN) then            
        delta_z = 1
    end

    if isKeyDown(Keyboard.KEY_LEFT) then            
        delta_x = -1
    end

    if isKeyDown(Keyboard.KEY_RIGHT) then            
        delta_x = 1
    end
    
    if isKeyDown(Keyboard.KEY_W) and vehicle:getRemainingFuelPercentage() > 0 then       
        local curr_z = vehicle:getWorldPos(0, 0, 0, tempVector2):z()
        if curr_z < 5.5 then
            move_vehicle(vehicle, 0, 0.04, 0)
        else
            move_vehicle(vehicle, 0, 0, 0)
        end
    end

    if isKeyDown(Keyboard.KEY_S) or (vehicle:getRemainingFuelPercentage() <= 0 and vehicle:getWorldPos(0, 0, 0, tempVector2):z() > 0.1) then    
        move_vehicle(vehicle, 0, -0.03, 0)
    end

    if delta_x == 0 and delta_z == 0 then
        --vehicle:setAngles(0, vehicle:getAngleY(), 0)
    elseif delta_x == 1 and delta_z == -1 then
        vehicle:setAngles(-30, 125, 20)
        delta_x = 0.5
        delta_z = -0.5
    elseif delta_x == 1 and delta_z == 0 then
        vehicle:setAngles(90, 65, -90)
    elseif delta_x == 1 and delta_z == 1 then
        vehicle:setAngles(35, 45, -25)
        delta_x = 0.5
        delta_z = 0.5
    elseif delta_x == 0 and delta_z == -1 then
        vehicle:setAngles(-25, -180, 0)
    elseif delta_x == 0 and delta_z == 1 then
        vehicle:setAngles(-155, -180, -180)
    elseif delta_x == -1 and delta_z == -1 then
        vehicle:setAngles(-25, -135, -20)
        delta_x = -0.5
        delta_z = -0.5
    elseif delta_x == -1 and delta_z == 0 then
        vehicle:setAngles(90, -65, 90)
    elseif delta_x == -1 and delta_z == 1 then
        vehicle:setAngles(25, -45, 25)
        delta_x = -0.5
        delta_z = 0.5
    end

    if vehicle:getRemainingFuelPercentage() > 0 then
        move_vehicle(vehicle, delta_x*0.5, 0, delta_z*0.5)
    end
end


local function heliSoundUpdate()
    local playerObj = getPlayer()
    if playerObj == nil then return end
    local vehicle = playerObj:getVehicle()
    if vehicle == nil then return end
    if vehicle:getScript():getFullName() ~= "Base.AI_helicopter_veh" then return end

    vehicle:update()
    local emi = vehicle:getEmitter()
    if emi:isPlaying("VehicleSkid") then
        emi:stopSoundByName("VehicleSkid")
    end

    if emi:isPlaying("HeliSound") and not vehicle:isEngineRunning() then 
		emi:stopSoundByName("HeliSound") 
	end
    if not vehicle:isEngineRunning() then return end

    
    if emi:isPlaying("HeliSound") then return end

	local songId = emi:playAmbientLoopedImpl("HeliSound")
    playerObj:getModData()["HeliSound"] = songId
    playerObj:getModData()["HeliSoundEmi"] = emi
    playerObj:getModData()["LastHeli"] = vehicle
	emi:setVolume(songId, 0.9)
end


Events.OnTick.Add(heli_update)
Events.OnTick.Add(heliSoundUpdate)


